diff --git a/src/main/java/net/minecraft/core/world/biome/Biomes.java b/src/main/java/net/minecraft/core/world/biome/Biomes.java
index 12e736592..c5e36fe66 100644
--- a/src/main/java/net/minecraft/core/world/biome/Biomes.java
+++ b/src/main/java/net/minecraft/core/world/biome/Biomes.java
@@ -1,35 +1,35 @@
 package net.minecraft.core.world.biome;
 
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
-import net.minecraft.core.world.weather.Weather;
+import net.minecraft.core.world.weather.Weathers;
 
 public class Biomes
 {
 
-    public static final Biome OVERWORLD_RAINFOREST = register("minecraft:overworld.rainforest", new BiomeRainforest("rainforest").setColor(0x1cf100).setBlockedWeathers(Weather.overworldSnow));
+    public static final Biome OVERWORLD_RAINFOREST = register("minecraft:overworld.rainforest", new BiomeRainforest("rainforest").setColor(0x1cf100).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
     public static final Biome OVERWORLD_SWAMPLAND = register("minecraft:overworld.swampland", new BiomeSwamp("swampland").setColor(0x00ff78));
     public static final Biome OVERWORLD_SEASONAL_FOREST = register("minecraft:overworld.seasonal_forest", new BiomeSeasonalForest("seasonal_forest").setColor(0x64ce15));
     public static final Biome OVERWORLD_FOREST = register("minecraft:overworld.forest", new BiomeForest("forest").setColor(0x26a615));
-    public static final Biome OVERWORLD_GRASSLANDS = register("minecraft:overworld.grasslands", new Biome("grasslands").setColor(0xf0f048).setBlockedWeathers(Weather.overworldSnow));
-    public static final Biome OVERWORLD_OUTBACK = register("minecraft:overworld.outback", new BiomeOutback("outback").setColor(0xd95e20).setBlockedWeathers(Weather.overworldSnow).setTopBlock(Block.dirtScorched.id).setFillerBlock(Block.dirtScorched.id));
+    public static final Biome OVERWORLD_GRASSLANDS = register("minecraft:overworld.grasslands", new Biome("grasslands").setColor(0xf0f048).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
+    public static final Biome OVERWORLD_OUTBACK = register("minecraft:overworld.outback", new BiomeOutback("outback").setColor(0xd95e20).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.DIRT_SCORCHED.id).setFillerBlock(Blocks.DIRT_SCORCHED.id));
     public static final Biome OVERWORLD_SHRUBLAND = register("minecraft:overworld.shrubland", new BiomeShrubland("shrubland").setColor(0xbaba38));
     public static final Biome OVERWORLD_TAIGA = register("minecraft:overworld.taiga", new BiomeTaiga("taiga").setColor(0x8abcff).setSurfaceSnow());
     public static final Biome OVERWORLD_BOREAL_FOREST = register("minecraft:overworld.boreal_forest", new BiomeBorealForest("boreal_forest").setColor(0x148564));
-    public static final Biome OVERWORLD_DESERT = register("minecraft:overworld.desert", new BiomeDesert("desert").setColor(0xEDE26F).setBlockedWeathers(Weather.overworldRain, Weather.overworldSnow, Weather.overworldStorm).setTopBlock(Block.sand.id).setFillerBlock(Block.sand.id));
+    public static final Biome OVERWORLD_DESERT = register("minecraft:overworld.desert", new BiomeDesert("desert").setColor(0xEDE26F).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM).setTopBlock(Blocks.SAND.id).setFillerBlock(Blocks.SAND.id));
     public static final Biome OVERWORLD_PLAINS = register("minecraft:overworld.plains", new BiomePlains("plains").setColor(0xA3C649));
-    public static final Biome OVERWORLD_GLACIER = register("minecraft:overworld.glacier", new Biome("glacier").setColor(0xcbf6ff).setSurfaceSnow().setTopBlock(Block.blockSnow.id).setFillerBlock(Block.blockSnow.id));
+    public static final Biome OVERWORLD_GLACIER = register("minecraft:overworld.glacier", new Biome("glacier").setColor(0xcbf6ff).setSurfaceSnow().setTopBlock(Blocks.BLOCK_SNOW.id).setFillerBlock(Blocks.BLOCK_SNOW.id));
     public static final Biome OVERWORLD_TUNDRA = register("minecraft:overworld.tundra", new Biome("tundra").setColor(0x57e0ff).setSurfaceSnow());
     public static final Biome OVERWORLD_MEADOW = register("minecraft:overworld.meadow", new BiomeBorealForest("meadow").setColor(0x8c8c22));
-    public static final Biome NETHER_NETHER = register("minecraft:nether.nether", new BiomeNether("nether").setColor(0xDD0000).setBlockedWeathers(Weather.overworldRain, Weather.overworldSnow, Weather.overworldStorm, Weather.overworldFog));
-    public static final Biome PARADISE_PARADISE = register("minecraft:paradise.paradise", new BiomeParadise("paradise").setColor(0x8080FF).setBlockedWeathers(Weather.overworldRain, Weather.overworldSnow, Weather.overworldStorm, Weather.overworldFog));
+    public static final Biome NETHER_NETHER = register("minecraft:nether.nether", new BiomeNether("nether").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG));
+    public static final Biome PARADISE_PARADISE = register("minecraft:paradise.paradise", new BiomeParadise("paradise").setColor(0x8080FF).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG));
     public static final Biome OVERWORLD_BIRCH_FOREST = register("minecraft:overworld.birch_forest", new BiomeBirchForest("birch_forest").setColor(0x4bcb5e));
-    public static final Biome OVERWORLD_RETRO = register("minecraft:overworld.retro", new BiomeRetro("retro").setColor(0x76B14A).setTopBlock(Block.grassRetro.id));
-    public static final Biome OVERWORLD_HELL = register("minecraft:overworld.hell", new Biome("hell").setColor(0xD96223).setTopBlock(Block.dirtScorched.id).setTopBlock(Block.dirtScorched.id));
+    public static final Biome OVERWORLD_RETRO = register("minecraft:overworld.retro", new BiomeRetro("retro").setColor(0x76B14A).setTopBlock(Blocks.GRASS_RETRO.id));
+    public static final Biome OVERWORLD_HELL = register("minecraft:overworld.hell", new Biome("hell").setColor(0xD96223).setTopBlock(Blocks.DIRT_SCORCHED.id).setTopBlock(Blocks.DIRT_SCORCHED.id));
     public static final Biome OVERWORLD_SWAMPLAND_MUDDY = register("minecraft:overworld.swampland.muddy", new BiomeSwamp("swampland.muddy").setColor(0x522700));
-    public static final Biome OVERWORLD_OUTBACK_GRASSY = register("minecraft:overworld.outback.grassy", new BiomeOutback("outback.grassy").setColor(0xf09037).setBlockedWeathers(Weather.overworldSnow).setTopBlock(Block.grassScorched.id).setFillerBlock(Block.dirtScorched.id));
-    public static final Biome OVERWORLD_CAATINGA = register("minecraft:overworld.caatinga", new BiomeCaatinga("caatinga").setColor(0xdecda6).setTopBlock(Block.mudBaked.id).setFillerBlock(Block.mudBaked.id).setBlockedWeathers(Weather.overworldSnow));
-    public static final Biome OVERWORLD_CAATINGA_PLAINS = register("minecraft:overworld.caatinga.plains", new Biome("caatinga.plains").setColor(0xa19477).setTopBlock(Block.mudBaked.id).setFillerBlock(Block.mudBaked.id).setBlockedWeathers(Weather.overworldSnow));
+    public static final Biome OVERWORLD_OUTBACK_GRASSY = register("minecraft:overworld.outback.grassy", new BiomeOutback("outback.grassy").setColor(0xf09037).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.GRASS_SCORCHED.id).setFillerBlock(Blocks.DIRT_SCORCHED.id));
+    public static final Biome OVERWORLD_CAATINGA = register("minecraft:overworld.caatinga", new BiomeCaatinga("caatinga").setColor(0xdecda6).setTopBlock(Blocks.MUD_BAKED.id).setFillerBlock(Blocks.MUD_BAKED.id).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
+    public static final Biome OVERWORLD_CAATINGA_PLAINS = register("minecraft:overworld.caatinga.plains", new Biome("caatinga.plains").setColor(0xa19477).setTopBlock(Blocks.MUD_BAKED.id).setFillerBlock(Blocks.MUD_BAKED.id).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
     public static Biome register(String key, Biome biome)
     {
         Registries.BIOMES.register(key, biome);
diff --git a/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index a8a8848b4..29ef04308 100644
--- a/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -1,20 +1,15 @@
 package net.minecraft.core.world.chunk;
 
-import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.world.data.ChunkNibbleArray;
-import net.minecraft.core.world.data.ChunkUnsignedByteArray;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockTileEntity;
+import net.minecraft.core.block.EntityBlock;
 
-import java.nio.ByteBuffer;
-import java.nio.ShortBuffer;
 import java.util.*;
 
 public class Chunk
@@ -30,7 +25,7 @@ public class Chunk
     public int lowestY;
     public final int xPosition;
     public final int zPosition;
-    public Map<ChunkPosition, TileEntity> tileEntityMap;
+    public Map<ChunkPosition, BlockEntity> blockEntityMap;
     public double[] temperature;
     public double[] humidity;
     public double[] variety;
@@ -44,7 +39,7 @@ public class Chunk
 
     public Chunk(World world, int x, int z)
     {
-        tileEntityMap = new HashMap<>();
+        blockEntityMap = new HashMap<>();
         isTerrainPopulated = false;
         isModified = false;
         hasEntities = false;
@@ -302,7 +297,7 @@ public class Chunk
         lightGaps(x, z);
 
         if(Block.getBlock(id) != null) {
-            Block.blocksList[id].onBlockAdded(world, worldX, y, worldZ);
+            Block.blocksList[id].onBlockPlacedByWorld(world, worldX, y, worldZ);
         }
 
         isModified = true;
@@ -441,14 +436,14 @@ public class Chunk
     public void addEntity(Entity entity)
     {
         hasEntities = true;
-        int x = MathHelper.floor_double(entity.x / CHUNK_SIZE_X);
-        int z = MathHelper.floor_double(entity.z / CHUNK_SIZE_Z);
+        int x = MathHelper.floor(entity.x / CHUNK_SIZE_X);
+        int z = MathHelper.floor(entity.z / CHUNK_SIZE_Z);
         if(x != xPosition || z != zPosition)
         {
             System.out.println("Wrong location! " + entity);
             Thread.dumpStack();
         }
-        int section = MathHelper.clamp(MathHelper.floor_double(entity.y / 16D), 0, CHUNK_SECTIONS - 1);
+        int section = MathHelper.clamp(MathHelper.floor(entity.y / 16D), 0, CHUNK_SECTIONS - 1);
         entity.addedToChunk = true;
         entity.chunkCoordX = xPosition;
         entity.chunkCoordY = section;
@@ -472,71 +467,71 @@ public class Chunk
         return y >= getHeightValue(x, z);
     }
 
-    public TileEntity getTileEntity(int x, int y, int z)
+    public BlockEntity getBlockEntity(int x, int y, int z)
     {
         ChunkPosition pos = new ChunkPosition(x, y, z);
-        TileEntity tileEntity = tileEntityMap.get(pos);
-        if(tileEntity == null)
+        BlockEntity blockEntity = blockEntityMap.get(pos);
+        if(blockEntity == null)
         {
             int id = getBlockID(x, y, z);
             if(!Block.isEntityTile[id])
             {
                 return null;
             }
-            BlockTileEntity tileEntityBlock = (BlockTileEntity)Block.blocksList[id];
-            tileEntityBlock.onBlockAdded(world, xPosition * CHUNK_SIZE_X + x, y, zPosition * CHUNK_SIZE_Z + z);
-            tileEntity = tileEntityMap.get(pos);
+            EntityBlock tileEntityBlock = (EntityBlock)Block.blocksList[id];
+            tileEntityBlock.onBlockPlacedByWorld(world, xPosition * CHUNK_SIZE_X + x, y, zPosition * CHUNK_SIZE_Z + z);
+            blockEntity = blockEntityMap.get(pos);
         }
-        if(tileEntity != null && tileEntity.isInvalid())
+        if(blockEntity != null && blockEntity.isInvalid())
         {
-            tileEntityMap.remove(pos);
+            blockEntityMap.remove(pos);
             return null;
         }
         else
         {
-            return tileEntity;
+            return blockEntity;
         }
     }
 
-    public void addTileEntity(TileEntity tileEntity)
+    public void addBlockEntity(BlockEntity blockEntity)
     {
-        int x = tileEntity.x - xPosition * CHUNK_SIZE_X;
-        int y = tileEntity.y;
-        int z = tileEntity.z - zPosition * CHUNK_SIZE_Z;
-        setTileEntity(x, y, z, tileEntity);
+        int x = blockEntity.x - xPosition * CHUNK_SIZE_X;
+        int y = blockEntity.y;
+        int z = blockEntity.z - zPosition * CHUNK_SIZE_Z;
+        setBlockEntity(x, y, z, blockEntity);
         if(isLoaded)
         {
-            world.loadedTileEntityList.add(tileEntity);
+            world.loadedBlockEntityList.add(blockEntity);
         }
     }
 
-    public void setTileEntity(int x, int y, int z, TileEntity tileEntity)
+    public void setBlockEntity(int x, int y, int z, BlockEntity blockEntity)
     {
         ChunkPosition chunkposition = new ChunkPosition(x, y, z);
-        tileEntity.worldObj = world;
-        tileEntity.x = xPosition * CHUNK_SIZE_X + x;
-        tileEntity.y = y;
-        tileEntity.z = zPosition * CHUNK_SIZE_Z + z;
-        if (getBlockID(x, y, z) == 0 || !(Block.blocksList[getBlockID(x, y, z)] instanceof BlockTileEntity))
+        blockEntity.worldObj = world;
+        blockEntity.x = xPosition * CHUNK_SIZE_X + x;
+        blockEntity.y = y;
+        blockEntity.z = zPosition * CHUNK_SIZE_Z + z;
+        if (getBlockID(x, y, z) == 0 || !(Block.blocksList[getBlockID(x, y, z)] instanceof EntityBlock))
         {
             System.out.println("Attempted to place a tile entity where there was no entity tile!");
         }
         else
         {
-            tileEntity.validate();
-            tileEntityMap.put(chunkposition, tileEntity);
+            blockEntity.validate();
+            blockEntityMap.put(chunkposition, blockEntity);
         }
     }
 
-    public void removeTileEntity(int x, int y, int z)
+    public void removeBlockEntity(int x, int y, int z)
     {
         ChunkPosition pos = new ChunkPosition(x, y, z);
         if(isLoaded)
         {
-            TileEntity tileEntity = tileEntityMap.remove(pos);
-            if(tileEntity != null)
+            BlockEntity blockEntity = blockEntityMap.remove(pos);
+            if(blockEntity != null)
             {
-                tileEntity.invalidate();
+                blockEntity.invalidate();
             }
         }
     }
@@ -544,7 +539,7 @@ public class Chunk
     public void onLoad()
     {
         isLoaded = true;
-        world.func_31054_a(tileEntityMap.values());
+        world.addAllBlockEntities(blockEntityMap.values());
 
         for (ChunkSection section : sections) {
             section.onLoad(world);
@@ -554,8 +549,8 @@ public class Chunk
     public void onUnload()
     {
         isLoaded = false;
-        TileEntity tileentity;
-        for(Iterator<TileEntity> iterator = tileEntityMap.values().iterator(); iterator.hasNext(); tileentity.invalidate())
+        BlockEntity tileentity;
+        for(Iterator<BlockEntity> iterator = blockEntityMap.values().iterator(); iterator.hasNext(); tileentity.invalidate())
         {
             tileentity = iterator.next();
         }
@@ -572,8 +567,8 @@ public class Chunk
 
     public void getEntitiesWithin(Entity toExclude, AABB aabb, List<Entity> entities)
     {
-        int minSection = Math.max(0, MathHelper.floor_double((aabb.minY - 2D) / 16D));
-        int maxSection = Math.min(MathHelper.floor_double((aabb.maxY + 2D) / 16D), CHUNK_SECTIONS - 1);
+        int minSection = Math.max(0, MathHelper.floor((aabb.minY - 2D) / 16D));
+        int maxSection = Math.min(MathHelper.floor((aabb.maxY + 2D) / 16D), CHUNK_SECTIONS - 1);
         for(int section = minSection; section <= maxSection; section++) {
             getSection(section).getEntitiesWithin(toExclude, aabb, entities);
         }
@@ -581,8 +576,8 @@ public class Chunk
 
     public void getEntitiesWithin(Class<? extends Entity> ofClass, AABB aabb, List<Entity> entities)
     {
-        int minSection = Math.max(0, MathHelper.floor_double((aabb.minY - 2D) / 16D));
-        int maxSection = Math.min(MathHelper.floor_double((aabb.maxY + 2D) / 16D), CHUNK_SECTIONS - 1);
+        int minSection = Math.max(0, MathHelper.floor((aabb.minY - 2D) / 16D));
+        int maxSection = Math.min(MathHelper.floor((aabb.maxY + 2D) / 16D), CHUNK_SECTIONS - 1);
         for(int section = minSection; section <= maxSection; section++) {
             getSection(section).getEntitiesWithin(ofClass, aabb, entities);
         }
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index bd0db92c0..a291db9a6 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -2,14 +2,14 @@ package net.minecraft.core.world.chunk;
 
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
 
 // Referenced classes of package net.minecraft.src:
 //            IBlockAccess, World, Chunk, WorldProvider, 
-//            Block, Material, TileEntity, WorldChunkManager
+//            Block, Material, BlockEntity, WorldChunkManager
 
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.biome.Biome;
@@ -75,11 +75,11 @@ public class ChunkCache
     }
 
     @Override
-	public TileEntity getBlockTileEntity(int x, int y, int z)
+	public BlockEntity getBlockEntity(int x, int y, int z)
     {
         int l = Math.floorDiv(x, Chunk.CHUNK_SIZE_X) - chunkX;
         int i1 = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z) - chunkZ;
-        return chunkArray[l][i1].getTileEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
+        return chunkArray[l][i1].getBlockEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
     }
 
     public boolean getBlockLitInteriorSurface(int i, int j, int k)
@@ -253,7 +253,7 @@ public class ChunkCache
             return false;
         } else
         {
-            return block.blockMaterial.blocksMotion() && block.renderAsNormalBlock();
+            return block.blockMaterial.blocksMotion() && block.isCubeShaped();
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java b/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
index b5a46b847..f18e68706 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
@@ -15,7 +15,7 @@ import net.minecraft.core.world.chunk.writer.ChunkWriter;
 import net.minecraft.core.world.data.ChunkNibbleArray;
 import net.minecraft.core.world.data.ChunkUnsignedByteArray;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.world.save.LevelData;
 
 import java.io.*;
@@ -197,10 +197,10 @@ public class ChunkLoaderLegacy
         // Write tile entities
         ListTag tileEntityListTag = new ListTag();
         CompoundTag tileEntityTag;
-        for (TileEntity tileEntity : chunk.tileEntityMap.values())
+        for (BlockEntity blockEntity : chunk.blockEntityMap.values())
         {
             tileEntityTag = new CompoundTag();
-            tileEntity.writeToNBT(tileEntityTag);
+            blockEntity.writeToNBT(tileEntityTag);
             tileEntityListTag.addTag(tileEntityTag);
         }
         tag.put("TileEntities", tileEntityListTag);
@@ -295,10 +295,10 @@ public class ChunkLoaderLegacy
                 if (tileEntityTagBase instanceof CompoundTag)
                 {
                     CompoundTag tileEntityTag = (CompoundTag) tileEntityTagBase;
-                    TileEntity tileEntity = TileEntity.createAndLoadEntity(tileEntityTag);
-                    if (tileEntity != null)
+                    BlockEntity blockEntity = BlockEntity.createAndLoadEntity(tileEntityTag);
+                    if (blockEntity != null)
                     {
-                        chunk.addTileEntity(tileEntity);
+                        chunk.addBlockEntity(blockEntity);
                     }
                 }
             }
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java b/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
index 807e9aaee..389403e53 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.chunk;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.LightLayer;
@@ -149,7 +150,7 @@ public class ChunkSection {
 
     public void getEntitiesWithin(Entity toExclude, AABB aabb, List<Entity> entities) {
         for (Entity e : this.entities) {
-            if (e != toExclude && e.bb.intersectsWith(aabb)) {
+            if (e != toExclude && e.bb.intersects(aabb)) {
                 entities.add(e);
             }
         }
@@ -157,7 +158,7 @@ public class ChunkSection {
 
     public void getEntitiesWithin(Class<? extends Entity> ofClass, AABB aabb, List<Entity> entities) {
         for (Entity e : this.entities) {
-            if (ofClass.isAssignableFrom(e.getClass()) && e.bb.intersectsWith(aabb)) {
+            if (ofClass.isAssignableFrom(e.getClass()) && e.bb.intersects(aabb)) {
                 entities.add(e);
             }
         }
diff --git a/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java b/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
index ec705341c..3a7610e04 100644
--- a/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
+++ b/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world.chunk;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
 
@@ -10,7 +10,7 @@ public class DisplayChunk extends EmptyChunk{
     public static int displayBlockPosX = 0;
     public static int displayBlockPosY = 0;
     public static int displayBlockPosZ = 0;
-    public static TileEntity displayTileEntity = null;
+    public static BlockEntity displayBlockEntity = null;
     public DisplayChunk(World world, int x, int z) {
         super(world, x, z);
     }
@@ -36,39 +36,39 @@ public class DisplayChunk extends EmptyChunk{
         return 15;
     }
     @Override
-    public void setTileEntity(int x, int y, int z, TileEntity tileEntity)
+    public void setBlockEntity(int x, int y, int z, BlockEntity blockEntity)
     {
         if (x == displayBlockPosX && y == displayBlockPosY && z == displayBlockPosZ){
-            displayTileEntity = tileEntity;
-            displayTileEntity.worldObj = world;
-            displayTileEntity.x = x;
-            displayTileEntity.y = y;
-            displayTileEntity.z = z;
+            displayBlockEntity = blockEntity;
+            displayBlockEntity.worldObj = world;
+            displayBlockEntity.x = x;
+            displayBlockEntity.y = y;
+            displayBlockEntity.z = z;
         }
     }
 
     @Override
-    public void removeTileEntity(int x, int y, int z)
+    public void removeBlockEntity(int x, int y, int z)
     {
         if (x == displayBlockPosX && y == displayBlockPosY && z == displayBlockPosZ){
-            displayTileEntity = null;
+            displayBlockEntity = null;
         }
     }
     @Override
-    public TileEntity getTileEntity(int x, int y, int z)
+    public BlockEntity getBlockEntity(int x, int y, int z)
     {
         if (x == displayBlockPosX && y == displayBlockPosY && z == displayBlockPosZ){
-            return displayTileEntity;
+            return displayBlockEntity;
         }
         return null;
     }
-    public static void setDisplayTileEntity(World world, TileEntity entity){
-        displayTileEntity = entity;
-        if (displayTileEntity != null){
-            displayTileEntity.worldObj = world;
-            displayTileEntity.x = DisplayChunk.displayBlockPosX;
-            displayTileEntity.y = DisplayChunk.displayBlockPosY;
-            displayTileEntity.z = DisplayChunk.displayBlockPosZ;
+    public static void setDisplayTileEntity(World world, BlockEntity entity){
+        displayBlockEntity = entity;
+        if (displayBlockEntity != null){
+            displayBlockEntity.worldObj = world;
+            displayBlockEntity.x = DisplayChunk.displayBlockPosX;
+            displayBlockEntity.y = DisplayChunk.displayBlockPosY;
+            displayBlockEntity.z = DisplayChunk.displayBlockPosZ;
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java b/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
index ad13559c1..37020d40c 100644
--- a/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
+++ b/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.world.chunk;
 
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.enums.LightLayer;
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.world.World;
 
 import java.util.Arrays;
@@ -12,7 +12,7 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            Chunk, World, EnumSkyBlock, Entity, 
-//            TileEntity, AxisAlignedBB
+//            BlockEntity, AxisAlignedBB
 
 public class EmptyChunk extends Chunk
 {
@@ -113,23 +113,23 @@ public class EmptyChunk extends Chunk
     }
 
     @Override
-	public TileEntity getTileEntity(int x, int y, int z)
+	public BlockEntity getBlockEntity(int x, int y, int z)
     {
         return null;
     }
 
     @Override
-	public void addTileEntity(TileEntity tileEntity)
+	public void addBlockEntity(BlockEntity blockEntity)
     {
     }
 
     @Override
-	public void setTileEntity(int x, int y, int z, TileEntity tileEntity)
+	public void setBlockEntity(int x, int y, int z, BlockEntity blockEntity)
     {
     }
 
     @Override
-	public void removeTileEntity(int x, int y, int z)
+	public void removeBlockEntity(int x, int y, int z)
     {
     }
 
diff --git a/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java b/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java
index 386d2119d..46403e045 100644
--- a/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java
+++ b/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java
@@ -4,6 +4,7 @@ package net.minecraft.core.world.chunk;
 //            World, Chunk, Block, EnumSkyBlock
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
 
diff --git a/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java b/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java
index ecb6bca18..c45e05b97 100644
--- a/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java
+++ b/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java
@@ -5,6 +5,7 @@ package net.minecraft.core.world.chunk;
 //            Block
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 
 public class MissingBlockFixer
 {
